import axios from 'axios'//引入axios;
import qs from 'qs';
import toast from "../components/toast/toast.js"//默认提示框组件//不需要注册----
import success from "../components/success/success.js"//默认成功组件//不需要注册----

const serivce = axios.create({ // 创建服务
    timeout: 60000 // 请求延时
})
//请求拦截器
serivce.interceptors.request.use(
    config => {
        /*header加token、多语言*/
        if (!!localStorage.getItem("token")) {config.headers['token'] = localStorage.getItem("token");}
        if (!!localStorage.getItem("language")) {config.headers['lan'] = localStorage.getItem("language");}
        if(config.method === "post"){
            /* 修改post Content-type*/
            config.headers["Content-type"]= 'application/x-www-form-urlencoded'
            /*判断是否是new FormData类型*/
            if(!(config.data instanceof FormData)){
                config.data = qs.stringify(config.data);
            }
        }
        return config;
    },
    err => {
        toast.info("请求参数错误")
        return Promise.reject(err);
    });
serivce.interceptors.response.use(
    response => {
        if(response.data.status==1&&((response.data.msg&&typeof response.data.msg === "string")||(response.data.info&&typeof response.data.info === "string"))){
            if(response.data.msg||response.data.info)success.info(response.data.msg||response.data.info)
        }
        if(response.data.status!=1){
            if(response.data.msg||response.data.info)toast.info(response.data.msg||response.data.info)
            return Promise.reject(response.data)
        }
        return response.data
    },
    error => {
        toast.info("网络异常")
        return Promise.reject(error)
    }
)
export default serivce
