export {parentMixin, childMixin}
/*父组件*/
const parentMixin = {
    data() {
        return {
            index: -1,
            currentIndex: this.index,
            number: this.$children.length,
            itemWidth:0,//item单个宽度
            itemleft:0,//item距离外容器左边距离
            tiemRight:0,//item距离外容器右边边距离
        }
    },
    props: {
        value: Number
    },
    watch: {
        currentIndex(val, oldVal) {
            if (val > oldVal) {
                this.direction = "forward"
            } else {
                this.direction = "backward"
            }
            oldVal > -1 && this.$children[oldVal] && (this.$children[oldVal].currentSelected = false)
            val > -1 && this.$children[val] && (this.$children[val].currentSelected = true)
            this.itemWidth = this.$children[val].$el.offsetWidth
            this.itemleft = this.$children[val].$el.offsetLeft
            this.tiemRight = (this.$children[this.number-1].$el.offsetLeft+this.$children[this.number-1].$el.offsetWidth)-(this.itemleft+this.itemWidth)
            this.$emit('input', val)
        },
        index(val) {
            this.currentIndex = val
        },
        value(val) {
            this.index = val
        }
    },
    mounted() {
        //执行赋值下标
        if (this.value >= 0) {
            this.currentIndex = this.value
        }
        this.updateIndex()
    },
    methods: {
        //给每个组件赋值标记下标
        updateIndex() {
            if (!this.$children || !this.$children.length) return
            this.number = this.$children.length
            let children = this.$children
            this.$nextTick(()=>{
                for (let i = 0; i < children.length; i++) {
                    children[i].currentIndex = i
                    if (children[i].currentSelected) {
                        this.index = i
                    }
                }
            })
        }
    }
}
/*子组件*/
const childMixin = {
    data() {
        return {
            currentIndex: -1,
            currentSelected: this.selected
        }
    },
    props: {
        selected: {
            type: Boolean,
            default: false
        }
    },
    watch: {
        currentSelected(val) {
            if (val) {
                this.$parent.index = this.currentIndex
            }
        },
        selected(val) {
            this.currentSelected = val
        }
    },
    mounted () {
        this.$parent.updateIndex()
    },
    methods: {
        onItemClick() {
            this.$parent.currentIndex = this.currentIndex
        }
    }
}
