import Vue from 'vue';
//引入组件
import success from "./success.vue"

//初始配置
const defaults = {
    duration: 2000,//默认关闭时间
}

//调用组件方法
function DoSuccess({content = '操作成功', duration = defaults.duration}) {
    const Instance = new Vue({
        render(h) {
            return h(success, {
                props: {
                    name: content,
                }
            });
        }
    });
    const component = Instance.$mount();
    //执行方法
    add(component.$el, Instance, parseInt(duration))
}

//添加元素
function add(dom, Instance, duration) {
    if (!document.querySelector('.XruUi-success')) {
        document.body.appendChild(dom);
        Instance.$children[0].open();
        //自动执行关闭方法//最小时间400
        setTimeout(() => {
            Instance.$children[0].close();
        }, (duration - 400))
        setTimeout(() => {
            remove(dom)
        }, duration)
    }
}

//移除元素
function remove(dom) {
    document.body.removeChild(dom);//移除元素
}

export default {
    name: "success",
    info: (options) => {
        if (typeof options === "string") {
            options = {
                content: options
            };
        }
        return DoSuccess({content: options.content || undefined, duration: options.duration || undefined})
    }
}
