import Vue from 'vue';
//引入组件
import toast from './toast.vue'

//初始配置
const defaults = {
    duration: 2000,//默认关闭时间
    type: "default",//弹出框位置（top,default,center,bottom）,//默认default
    width: "45%"
}

//调用组件方法
function DoToast({content = '提示', duration = defaults.duration, type = defaults.type, width = defaults.width}) {
    const Instance = new Vue({
        render(h) {
            return h(toast, {
                props: {
                    name: content,
                    type: type,
                    width: width,
                }
            });
        }
    });
    const component = Instance.$mount();
    //执行方法
    add(component.$el, Instance, parseInt(duration))
}

//添加元素
function add(dom, Instance, duration) {
    if (!document.querySelector('.XruUi-toast')) {
        document.body.appendChild(dom);
        Instance.$children[0].open();
        //自动执行关闭方法//最小时间400
        setTimeout(() => {
            Instance.$children[0].close();
        }, (duration - 400))
        setTimeout(() => {
            remove(dom)
        }, duration)
    }
}

//移除元素
function remove(dom) {
    document.body.removeChild(dom);//移除元素
}

export default {
    name: "toast",
    info: (options) => {
        if (typeof options === "string") {
            options = {
                content: options
            };
        }
        return DoToast({
            content: options.content || undefined,
            duration: options.duration || undefined,
            type: options.type || undefined,
            width: options.width || undefined
        })
    }
}

