//引入请求
import serivce from "./axios/index"//引入axios请求
import { md5 } from 'vux'
//引入过滤器
import timeGSH from "./filter/timeFilter"//引入时间过滤器
import otherFilter from "./filter/otherFilter"//引入其他过滤器

//引入全局混入
import mixin from "./mixin/mixin"//引入全局混入

//引入swiper插件
import Swiper from 'swiper';
import 'swiper/dist/css/swiper.min.css';

//引入复制插件
import VueClipboard from 'vue-clipboard2'

//引入vuex
import Vuex from 'vuex'

//引入组件(不需要注册)
import toast from "./components/toast/toast.js"//默认提示框组件//不需要注册----
import success from "./components/success/success.js"//默认成功组件//不需要注册----
//引入组件(需要注册)

import popup from "./components/popup/popup"
import backBlack from "./components/backBlack/backBlack"
import alert from "./components/alert/alert"
import confirm from "./components/confirm/confirm"
import tab from "./components/tab/tab"
import tabItem from "./components/tabItem/tabItem"
import modal from "./components/modal/modal"
import dateTime from "./components/dateTime/dateTime"
import scrollTab from "./components/scrollTab/scrollTab"
import scrollTabItem from "./components/scrollTabItem/scrollTabItem"
import timeLine from "./components/timeLine/timeLine"
import timeLineItem from "./components/timeLineItem/timeLineItem"
import card from "./components/card/card"
import number from "./components/number/number"
import countUp from "./components/countUp/countUp"
import phoneCode from "./components/phoneCode/phoneCode"
import checkAddress from "./components/checkAddress/checkAddress"
import handLock from "./components/handLock/handLock"
import slideVerify from "./components/slideVerify/slideVerify"
import sortABC from "./components/sortABC/sortABC"
//import swierContainer from "./components/swierContainer/swierContainer"//还不够完善，有bug
import divCon from "./components/divCon/divCon"
import pdf from "./components/pdf/pdf"
import pdfItem from "./components/pdfItem/pdfItem"


//把引入的组件名放到对象里处理
const components = {
    popup,
    backBlack,
    alert,
    confirm,
    tab,
    tabItem,
    modal,
    dateTime,
    scrollTab,
    scrollTabItem,
    timeLine,
    timeLineItem,
    card,
    number,
    countUp,
    phoneCode,
    checkAddress,
    handLock,
    sortABC,
    divCon,
    slideVerify,
    pdf,
    pdfItem,
}
/*注册全局组件*/
const ui = (Vue) => {
    Object.keys(components).forEach(key => {
        Vue.component(key, components[key]);
    });
    Vue.prototype.$xToast = toast;
    Vue.prototype.$success = success;
    Vue.prototype.$swiper = Swiper;
    Vue.prototype.$axios = serivce;
    Vue.prototype.$md5 = md5;
}
/*注册全局混入*/
const mixinHr = (Vue,{request,isTime,time,timeUrl,isLogin,loginStatus,loginUrl}) =>{
    mixin(Vue,{request,isTime,time,timeUrl,isLogin,loginStatus,loginUrl})
}
/*注册全局过滤器*/
const filter = (Vue) => {
    timeGSH(Vue)
    otherFilter(Vue)
}
/*注册全局插件*/
const awesome = (Vue) => {
    Vue.use(VueClipboard)
    Vue.use(Vuex)
}
/*公开方法*/
const install = (Vue,{request="",isTime=false,time = 600,timeUrl="/login/",isLogin = false,loginStatus = 998,loginUrl = "/login/"}={}) => {
    if (install.installed) return;
    awesome(Vue)//使用使用插件
    ui(Vue)//注册组件
    filter(Vue)//注册全局过滤器
    mixinHr(Vue,{request,isTime,time,timeUrl,isLogin,loginStatus,loginUrl})//request ajxa请求地址
};
// auto install
if (typeof window !== 'undefined' && window.Vue) {
    install(window.Vue);
}
const API = {
    install,
};
export default API
