import {  ChinaAddressV4Data} from 'vux'
let $time = null
/*注册全局混入方法*/
const mixin = (Vue,{request,isTime,time,timeUrl,isLogin,loginStatus,loginUrl}) =>{
    Vue.mixin({
        methods:{
            //f7框架专用调接口 post
            f7AxiosPost(methods,data,{isload=true,isCatch=false}={isload:true,isCatch:false}){
                if(isload){this.$f7.preloader.show()};//开启加载
                return new Promise((resolve,reject) => {
                    if(isTime){
                        clearTimeout($time)
                        $time = setTimeout(()=>{
                            localStorage.removeItem("token")
                            this.$f7router.navigate(timeUrl, {reloadAll:true,clearPreviousHistory:true})
                        },time*1000)
                    }
                    this.$axios.post(`${request}/${methods}`,data).then((res)=>{
                        if(isload){this.$f7.preloader.hide()};//关闭加载
                        resolve(res)
                    })
                        .catch((res)=>{
                            if(isload){this.$f7.preloader.hide()};//关闭加载
                            if(isCatch){reject(res)}
                            if(isLogin&&(res.status === loginStatus)){
                                this.$f7router.navigate(loginUrl, {reloadAll:true,clearPreviousHistory:true})
                            }
                        })
                })
            },
            //f7框架专用调接口 get
            f7AxiosGet(methods,data,{isload=true,isCatch=false}={isload:true,isCatch:false}){
                if(isload){this.$f7.preloader.show()};//开启加载
                return new Promise((resolve,reject) => {
                    if(isTime){
                        clearTimeout($time)
                        $time = setTimeout(()=>{
                            localStorage.removeItem("token")
                            this.$f7router.navigate(timeUrl, {reloadAll:true,clearPreviousHistory:true})
                        },time*1000)
                    }
                    this.$axios.get(`${request}/${methods}`,{params:data}).then((res)=>{
                        if(isload){this.$f7.preloader.hide()};//关闭加载
                        resolve(res)
                    })
                        .catch((res)=>{
                            if(isload){this.$f7.preloader.hide()};//关闭加载
                            if(isCatch){reject(res)}
                            if(isLogin&&(res.status === loginStatus)){
                                this.$f7router.navigate(loginUrl, {reloadAll:true,clearPreviousHistory:true})
                            }
                        })
                })
            },
            //获取省份
            getAddressArray(val){
                let arr = []
                if(val){
                    ChinaAddressV4Data.forEach(value=>{if(value.parent&&value.parent==val) arr.push(value)})/*查询市、区*/
                }else{
                    ChinaAddressV4Data.forEach(value=>{ if(!value.parent) arr.push(value);})/*查询省*/
                }
                return arr
            },
        }
    })
}
export default mixin
